/*
 * vim: ts=4 nobackup
 */


#include "ADCManager.H"
#include <stdint.h>
#include <avr/io.h>


using namespace avelino;
using namespace std;


void ADCManager::init() {
	ADCSRA |= (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);
	ADMUX |= (1 << REFS0);
	ADCSRA = (1 << ADEN);
}


uint16_t ADCManager::get(uint8_t input) {
	if (input >= 8) {
		input -= 8;
		ADCSRB |=  (1 << MUX5);
	}
	else
		ADCSRB &= ~(1 << MUX5);
	input &= 0x07;
	ADMUX |= input;
	ADCSRA |= (1 << ADSC);   // start conversion
	// wait for conversion complete
	while (!(ADCSRA & (1 << ADIF)))
		;
	ADCSRA |= (1 << ADIF);   // clear ADIF
	return ADC;
}


