/*
 * vim: ts=4 nobackup
 */


#ifndef  __I2C_H__
#define  __I2C_H__


#include <stdint.h>


extern "C++" {
	namespace avelino {
		class I2C {
			protected:
				static uint8_t status;
				static uint8_t address;
				static uint8_t *buffer;
				static uint16_t bufferIndex;
				static uint16_t bufferSize;
				static bool sendStopAtEnd;
			public:
				static void init();
				static void start();
				static void stop();
				static void write(uint8_t v);
				static void readACK();
				static void readNACK();
				static uint8_t getReaded();
				static bool isReady();
				static void writeSequence(uint8_t *data, uint16_t size, bool sendStop);
				static void readSequence(uint8_t addr, uint8_t *data, uint16_t size, bool sendStop);
				static bool sequenceDone();
				static void run();
		};
	}
}


#endif  // __I2C_H__
