/*
 * vim: ts=4 nobackup
 */


#ifndef  __MYLEDGROUP_H__
#define  __MYLEDGROUP_H__


#include <stdint.h>
#include "LedGroup.H"
#include "RTCListener.H"
#include "RTCResetButtonListener.H"


extern "C++" {
	namespace avelino {
		class MyLedGroup : public LedGroup, public RTCListener, public RTCResetButtonListener {
			protected:
				uint8_t currentHour;
				uint8_t currentMinute;
				uint8_t currentSecond;
			public:
				void init();
				uint8_t getNumLeds();
				void setLed(uint8_t index, bool v);
				void RTCChanged(uint8_t hour, uint8_t minute, uint8_t second);
				void RTCResetButtonPressed();
		};
	}
}


#endif  // __MYLEDGROUP_H__
