/*
 * vim: ts=4 nobackup
 */


#include <stdint.h>
#include <avr/io.h>
#include "MyLedGroup.H"


using namespace avelino;
using namespace std;


void MyLedGroup::init() {
	DDRC |= 0x80;   // led 0 at arduino pin 13
	DDRD |= 0x40;   // led 1 at arduino pin 12
	DDRB |= 0x80;   // led 2 at arduino pin 11
	DDRB |= 0x40;   // led 3 at arduino pin 10
	DDRB |= 0x20;   // led 4 at arduino pin  9
	this->currentHour = 0;
	this->currentMinute = 0;
	this->currentSecond = 0;
}


uint8_t MyLedGroup::getNumLeds() {
	return 5;
}


void MyLedGroup::setLed(uint8_t index, bool v) {
	if (index == 0) {
		if (v)
			PORTC |= 0x80;
		else
			PORTC &= (uint8_t) ~(0x80);
	}
	else if (index == 1) {
		if (v)
			PORTD |= 0x40;
		else
			PORTD &= (uint8_t) ~(0x40);
	}
	else if (index == 2) {
		if (v)
			PORTB |= 0x80;
		else
			PORTB &= (uint8_t) ~(0x80);
	}
	else if (index == 3) {
		if (v)
			PORTB |= 0x40;
		else
			PORTB &= (uint8_t) ~(0x40);
	}
	else if (index == 4) {
		if (v)
			PORTB |= 0x20;
		else
			PORTB &= (uint8_t) ~(0x20);
	}
}


void MyLedGroup::RTCChanged(uint8_t hour, uint8_t minute, uint8_t second) {
	if (this->currentHour != hour) {
			PORTC ^= 0x80;
			this->currentHour = hour;
	}
	if (this->currentMinute != minute) {
			PORTD ^= 0x40;
			this->currentMinute = minute;
	}
	if (this->currentSecond != second) {
			PORTB ^= 0x80;
			this->currentSecond = second;
	}
}


void MyLedGroup::RTCResetButtonPressed() {
	setLed(4, true);
}

