/*
 * vim: ts=4 nobackup
 */


#ifndef  __RTC_H__
#define  __RTC_H__


#include <stdint.h>


extern "C++" {
	namespace avelino {
		class RTC {
			protected:
				static uint8_t status;
				static uint8_t aux[4];
				static uint8_t haltByte;
				static bool hourMinuteSecondReadRequested;
				static bool hourMinuteSecondReadIsOk;
				static bool hourMinuteSecondWriteRequested;
				static bool hourMinuteSecondWriteIsOk;
				static uint8_t hourToWrite;
				static uint8_t minuteToWrite;
				static uint8_t secondToWrite;
			public:
				static uint8_t readedHour;
				static uint8_t readedMinute;
				static uint8_t readedSecond;
				static void init();
				static void requestHourMinuteSecondRead();
				static bool isHourMinuteSecondReadRequested();
				static bool isHourMinuteSecondReadOk();
				static void requestHourMinuteSecondWrite(uint8_t h, uint8_t m, uint8_t s);
				static bool isHourMinuteSecondWriteRequested();
				static bool isHourMinuteSecondWriteOk();
				static void run();
		};
	}
}


#endif  // __RTC_H__
