/*
 * vim: ts=4 nobackup
 */


#include <stdint.h>
#include "RTCObserver.H"
#include "Timer.H"
#include "RTC.H"


using namespace avelino;
using namespace std;


#define  DELAY_MS                    250
#define  TIMER_COUNTER_FOR_DELAY_MS  TIMER_COUNT_FROM_MS(DELAY_MS)


#define  RTC_OBSERVER_STATUS_IDLE              0
#define  RTC_OBSERVER_STATUS_READ_HMS          1
#define  RTC_OBSERVER_STATUS_WAIT_READ_HMS_OK  2


int8_t RTCObserver::timerHandler;
uint8_t RTCObserver::status;
RTCListener *RTCObserver::listener;


void RTCObserver::init(RTCListener &l) {
	timerHandler = Timer::alloc();
	status = RTC_OBSERVER_STATUS_IDLE;
	listener = &l;
}


void RTCObserver::run() {
	if (status == RTC_OBSERVER_STATUS_IDLE) {
		if (Timer::counter[timerHandler] == 0)
			status = RTC_OBSERVER_STATUS_READ_HMS;
	}
	else if (status == RTC_OBSERVER_STATUS_READ_HMS) {
		RTC::requestHourMinuteSecondRead();
		status = RTC_OBSERVER_STATUS_WAIT_READ_HMS_OK;
	}
	else if (status == RTC_OBSERVER_STATUS_WAIT_READ_HMS_OK) {
		if (RTC::isHourMinuteSecondReadOk()) {
			listener->RTCChanged(RTC::readedHour, RTC::readedMinute, RTC::readedSecond);
			Timer::counter[timerHandler] = TIMER_COUNTER_FOR_DELAY_MS;
			status = RTC_OBSERVER_STATUS_IDLE;
		}
	}
}

