/*
 * vim: ts=4 nobackup
 */


#ifndef  __STARSMANAGER_H__
#define  __STARSMANAGER_H__


#include <stdint.h>
#include "LedGroup.H"
#include "RTCListener.H"


extern "C++" {
	namespace avelino {
		class StarsManager : public RTCListener {
			protected:
				LedGroup *ledGroup;
				int8_t timerHandler;
				uint8_t probPercent;
			public:
				void init(LedGroup &lg);
				void setProbPercent(uint8_t v);
				void run();
				void RTCChanged(uint8_t hour, uint8_t minute, uint8_t second);
		};
	}
}


#endif  // __STARSMANAGER_H__
