/*
 * vim: ts=4 nobackup
 */


#include "util.H"
#include "Timer.H"
#include "MyLedGroup.H"
#include "RTC.H"
#include "RTCObserver.H"
#include "StarsManager.H"
#include "RTCResetButton.H"
#include "RTCResetLed.H"


using namespace std;
using namespace avelino;


MyLedGroup myLedGroup;
StarsManager starsManager;
RTCResetLed resetLed;


int main() {
	Timer::init();
	myLedGroup.init();
	RTC::init();
	starsManager.init(myLedGroup);
	RTCObserver::init(starsManager);
	resetLed.init();
	RTCResetButton::init(resetLed);
	while (true) {
		RTC::run();
		RTCObserver::run();
		RTCResetButton::run();
		resetLed.run();
		starsManager.run();
	}
	/*
	starsManager.init(myLedGroup);
	// starsManager.setProbPercent(10);   // day
	// starsManager.setProbPercent(80);   // night
	starsManager.setProbPercent(50);
	while (true) {
		starsManager.run();
	}
	*/
	return 0;
}
